:globe_with_meridians:  [english](README.md)	[český](README.cz.md)	**<u>русский</u>**

# Код проекта стимпанк часов Flutter Clock

## Содержание:
* [Описание](#Описание)
* [Лицензии](#Лицензии)
* [Кадры с реальных устройств](#Кадры-с-реальных-устройств)
* [Изменения](#Изменения)
* [Известные проблемы](#Известные-проблемы)
  * [Сборка APK файлов](#Сборка-APK-файлов)
  * [Плохая производительность на некоторых устройствах](#Плохая-производительность)
* [Технические данные](#Технические-данные)

![Скриншот](screenshot.jpg)

## Описание
Здесь находится весь код, относящийся к проекту стимпанк часов, конкурса Flutter Clock. Написание кода было регулировано правилами конкурса, больше о правилах, на английском языке, вы можете прочитать тут: [flutter.dev/clock](https://flutter.dev/clock).

## Лицензии
Код лицензируется по соответствующей лицензии с открытым исходным кодом (лицензия типа BSD или Калифорнийского университета), анимации в папке [assets](./assets) лицензируются с лицензией CC BY 4.0, а шрифт в папке [third_party](./third_party) содержит лицензию OFL. Вы можете найти файл с именем LICENSE, внутри папок, который содержит копию лицензии, с полным текстом этой лицензии, на английском языке.

## Кадры с реальных устройств

Здесь вы можете найти необработанные 4K-кадры с реальных устройств, работающих под управлением операционных систем iOS (iPhone, 2016 года) и Android (планшет 2-в-1, с 2013 года) с этими часами в стиле стимпанк.

Контрольные суммы:

MD5: ```85112361007BD86664C871030E1D3D55```

SHA-1: ```0CFCDFE7EA241C304CA694CC376983F11B1C6E6D```

[![Предварительный просмотр видео](https://drive.google.com/thumbnail?authuser=0&sz=w3840&id=1MEvmXMpxN4UaGxbnPOzpHPvQ4rkUYXqv)](https://1drv.ms/u/s!Aoc8-1_hYIfGiFPEwgpoCKerXyNC?e=TLMM3v)

[Dropbox](https://www.dropbox.com/sh/artyk72v9tckws3/AAAc5q7e0c70HiCDLuuiNN9Ia?dl=0) |
[Google Drive](https://drive.google.com/open?id=1XkKovGk6c6a0NpMadtCMXMx6KAM61RPp) | [Mega.nz](https://mega.nz/#F!5UlUzKBT!NZLFHkueFZT_SJWvZf1yAQ) |
[OneDrive](https://1drv.ms/u/s!Aoc8-1_hYIfGiFPEwgpoCKerXyNC?e=TLMM3v) |
[Amazon Drive](https://www.amazon.com/clouddrive/share/gtEpUwtoJYL0UvYkvPirVcsCnrloKuaGbtxKqbrCWlr) |
[iCloud](https://www.icloud.com/iclouddrive/0BYofNXgp-nZoBJBiTW_gIJlg#20200121%5F143234)

## Изменения
Главные изменения, которые были сделаны, исходя из примера от Гугла:
* удалены неиспользуемые файлы и папки,
* в этой [корневой](./) папке:
    * добавлены записи в [.gitignore](./.gitignore) файл,
    * добавлены [README.md](./README.md) файлы на разных языках,
    * [pubspec.yaml](./pubspec.yaml) — добавлена зависимость [Rive](https://rive.app) (бывшее Flare), изменено описание и версия фреймворка повышена на 2.7.0,
* в папке [lib](./lib):
    * [main.dart](./lib/main.dart) — настроен ландшафтный и полноэкранный режим, кэширование анимации, остальное без изменений,
    * [analog_clock.dart](./lib/analog_clock.dart) — удалены неиспользуемые переменные, декларирован контроллер анимации и изменены два метода, остальное без изменений,
    * добавлены [animation_controller.dart](./lib/animation_controller.dart) и [temperature_converter.dart](./lib/temperature_converter.dart),
* в папке [assets](./assets) — неиспользованная графика была заменена файлом анимации,
* в папке [ios](./ios) — аппликация настроена на запуск в ландшафтном режиме, добавлено уникальное название,
* в папке [android](./android) — изменён файл [build.gradle](./android/build.gradle) (смотрите Известные проблемы),
* добавлена папка [third_party](./third_party) с шрифтом и его лицензией.

**Добавленный или изменённый код был комментирован**, дабы было понятно, что он делает.
## Известные проблемы
На Андроид платформе имеются следующие технические проблемы:
#### Сборка APK файлов
Создание любого APK файла заканчивается ошибкой в терминале. Что бы исправить это, необходимо изменить зависимости в сценарии сборки, файла [build.gradle](./android/build.gradle) (в папке android). Последняя правильно работающая версия: 3.4.2, поэтому измените строку номер 9:
```markdown
classpath 'com.android.tools.build:gradle:3.5.0'
```
на
```markdown
classpath 'com.android.tools.build:gradle:3.4.2'
```
Проблема должна пропасть.

#### Плохая производительность
Анимации были приготовлены с частой кадров до **25 кадров в секунду**, тем не менее, на данный момент (январь 2020), некоторые Андроид устройства, не отображаются эти анимации плавно. Существует несколько открытых [Проблем](https://github.com/2d-inc/Flare-Flutter/issues) в репозитории flare_flutter относящиеся к плохой производительности сложных анимаций и команда Rive работает над их устранением вместе с командой Skia, поэтому в зависимости от даты, когда вы это читаете — у вас или будут или не появятся  подобные проблемы. В случае, если всё же у вас возникнут проблемы с производительностью, попробуйте заменить в зависимостях официальный пакет flare_flutter на [мой форк этого пакета](https://github.com/tsinis/flare-flutter), версии 2.0.1, с отключённым сглаживанием. Внутри файла [pubspec.yaml](./pubspec.yaml) (в этой корневой папке) поменяйте строку:
```markdown
  flare_flutter: ^2.0.1
```
на:
````markdown
  flare_flutter:
    git:
      url: git://github.com/tsinis/Flare-Flutter.git
      ref: stable
      path: flare_flutter
````
> **Примечание:** видимо, эта проблема зависит от конкретного устройства, так как я успешно запустил часы, без каких либо серьёзных потерь кадров, на планшете 2013 года, как видно на [кадрах с реальных устройств](#Кадры-с-реальных-устройств).

**На устройствах с системой iOS (айфоны) я не нашёл никаких проблем**, но прошу посылать отчёт или ваши решения, в секцию Issues.

## Технические данные

| Название | Описание |
| ---- | ----------- |
| **Название фреймворка** | [Flutter](https://flutter.dev) |
| Версия фреймворка | [1.12.13+hotfix.5](https://github.com/flutter/flutter) |
| Канал фреймворка | стабильный |
| **Название языка** | [Dart](https://dart.dev) |
| Версия языка | [2.7.0](https://github.com/dart-lang) |
| Канал языка | стабильный |
| **Название ИСР** | [Visual Studio Code](https://code.visualstudio.com/insiders/) |
| Версия ИСР | [1.42.0](https://github.com/microsoft/vscode) |
| Канал ИСР | предварительный |
| Название **сопредельной** зависимости | Flutter Clock Helper |
| Пакет **сопредельной** зависимости | [flutter_clock_helper](../flutter_clock_helper) |
| Название сторонней зависимости | [Rive](https://rive.app) (бывшее Flare) |
| Пакет сторонней зависимости | [flare_flutter](https://pub.dev/packages/flare_flutter) |
| Версия сторонней зависимости | [2.0.1](https://github.com/2d-inc/Flare-Flutter) |
| Канал сторонней зависимости | стабильный |
| Архитектура | По умолчанию (слушатель) |